package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.SysPlanInfoDTO;
import com.diagbot.dto.SysSetInfoDTO;
import com.diagbot.entity.SysPlan;
import com.diagbot.entity.SysSet;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.enums.StatusEnum;
import com.diagbot.enums.SysTypeEnum;
import com.diagbot.service.impl.SysPlanServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.StringUtil;
import com.diagbot.vo.HospitalPlanVO;
import com.diagbot.vo.HospitalSetVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author wangfeng
 * @Description:
 * @date 2020-07-27 19:23
 */
@Component
public class SysPlanFacade extends SysPlanServiceImpl {

    @Autowired
    SysSetFacade sysSetFacade;

    public SysPlanInfoDTO getSysPlanInfoData(HospitalPlanVO hospitalPlanVO) {
        SysPlanInfoDTO sysPlanInfoDTO = new SysPlanInfoDTO();
        QueryWrapper<SysPlan> sysPlanInfo = new QueryWrapper<>();
        sysPlanInfo.eq("is_deleted", IsDeleteEnum.N.getKey());
        sysPlanInfo.eq("hospital_id", hospitalPlanVO.getHospitalId());
        sysPlanInfo.eq(StringUtil.isNotBlank(hospitalPlanVO.getPlanCode()),"plan_code", hospitalPlanVO.getPlanCode());
        sysPlanInfo.eq("plan_status", StatusEnum.Enable.getKey());
        SysPlan sysPlanInfoData = getOne(sysPlanInfo, false);
        BeanUtil.copyProperties(sysPlanInfoData,sysPlanInfoDTO);
        if(sysPlanInfoDTO!=null){
            Long planId = sysPlanInfoDTO.getId();
            HospitalSetVO hospitalSetVO = new HospitalSetVO();
            hospitalSetVO.setHospitalId(hospitalPlanVO.getHospitalId());
            hospitalSetVO.setPlanId(planId);
            List<SysSetInfoDTO> sysSetInfoData = sysSetFacade.getSysSetInfoData(hospitalSetVO);
            sysPlanInfoDTO.setSysSetInfo(sysSetInfoData);
        }

      return sysPlanInfoDTO;
    }
}
